
/**
 * takecal.java
 *
 *
 * Created: Mon Jul 05 21:46 1999
 *
 * @author TAKEchi Masashi
 * @version 0.0
 */

import waba.ui.*;
import waba.fx.*;
import waba.io.*;
import waba.sys.*;

/**
 * A control that displays an application's title.
 * taken from Scribble example.
 */
class Title extends Control
{
    String name;
    Font font;
    
    public Title(String name){
	this.name=name;
	this.font=new Font("Helvetica", Font.BOLD, 12);
    }
    
    public void onPaint(Graphics g){
	// draw line across
	g.setColor(0, 0, 0);
	int y = this.height - 1;
	g.drawLine(0, y, this.width, y);
	y--;
	g.drawLine(0, y, this.width, y);
	
	// draw title
	FontMetrics fm = getFontMetrics(font);
	int boxWidth = fm.getTextWidth(name) + 8;
	g.fillRect(0, 0, boxWidth, y);
	g.setColor(255, 255, 255);
	g.setFont(font);
	g.drawText(name, 4, 2);
    }
}

/*
 * Wathello Main class.
 */
public class takecal extends MainWindow
{
    private Button closeButton;
    private Button tomorrow;
    private Button yesterday;
    private Button nextmon;
    private Button lastmon;
    Image RokuImage;
    String [] RokuName = new String[6];
    Image KyuseiImage;
    String [] KyuseiName = new String[9];
    Image EtoImage;
    String [] EtoName = new String[60];
    
    Graphics g = new Graphics(this);
    Font boldFont = new Font("Helvetica", Font.BOLD, 12);
    Font plainFont = new Font("Helvetica", Font.PLAIN, 12);
    Koyomi koyomi;

    public takecal()
    {
	set_rokuyo();
	set_kyusei();
	set_eto();

	Title title=new Title("Koyomi");
	title.setRect(0,0,this.width,15);
	add(title);
	
	closeButton=new Button("Close");
	closeButton.setRect(0,this.height-15,44,15);
	add(closeButton);

	lastmon=new Button("<<");
	lastmon.setRect(45,this.height-15,28,15);
	add(lastmon);

	yesterday=new Button("<");
	yesterday.setRect(74,this.height-15,28,15);
	add(yesterday);

	tomorrow=new Button(">");
	tomorrow.setRect(103,this.height-15,28,15);
	add(tomorrow);

	nextmon=new Button(">>");
	nextmon.setRect(132,this.height-15,28,15);
	add(nextmon);

	Time t=new Time();
	koyomi=new Koyomi(t.year,t.month,t.day);

    }
    public void onEvent(Event event){
	if (event.type==ControlEvent.PRESSED){
	    if(event.target==closeButton){
		exit(0);
	    }
	    else if(event.target==yesterday){
		OnKinou();
		repaint();
	    }
	    else if(event.target==tomorrow){
		OnAsu();
		repaint();
	    }
	    else if(event.target==nextmon){
		OnRaigetu();
		repaint();
	    }
	    else if(event.target==lastmon){
		OnSengetu();
		repaint();
	    }
	}
    }
    public void OnSengetu()
    {
        int i = koyomi.year;
        int j = koyomi.month;
        int k = 1;
        if(j>1){
            j--;
        }
        else{
            j = 12;
            i--;
        }
	koyomi.SetDay(i, j, k);
	return;
    }
    public void OnRaigetu()
    {
        int i = koyomi.year;
        int j = koyomi.month;
        int k = 1;
        if(j < 12){
            j++;
        }
        else{
            j = 1;
            i++;
        }
        if(i > 2005){
            return;
        }
        else{
            koyomi.SetDay(i, j, k);
            return;
        }
    }

    public void OnAsu()
    {
        int i = koyomi.year;
        int j = koyomi.month;
        int k = koyomi.day;
        switch(j){
        default:
            break;
        case 1:
            if(k < 31){
                k++;
            }
            else{
                j = 2;
                k = 1;
            }
            break;
        case 2:
            if(k < 28){
                k++;
                break;
            }
            if(koyomi.uru_flag == 1 && k == 28){
                k = 29;
            }
            else{
                j = 3;
                k = 1;
            }
            break;
        case 3:
            if(k < 31){
                k++;
            }
            else{
                j = 4;
                k = 1;
            }
            break;
        case 4:
            if(k < 30){
                k++;
            }
            else{
                j = 5;
                k = 1;
            }
            break;
        case 5:
            if(k < 31){
                k++;
            }
            else{
                j = 6;
                k = 1;
            }
            break;
        case 6:
            if(k < 30){
                k++;
            }
            else{
                j = 7;
                k = 1;
            }
            break;
        case 7:
            if(k < 31){
                k++;
            }
            else{
                j = 8;
                k = 1;
            }
            break;
        case 8:
            if(k < 31){
                k++;
            }
            else{
                j = 9;
                k = 1;
            }
            break;

        case 9:
            if(k < 30){
                k++;
            }
            else{
                j = 10;
                k = 1;
            }
            break;
        case 10:
            if(k < 31){
                k++;
            }
            else{
                j = 11;
                k = 1;
            }
            break;
        case 11:
            if(k < 30){
                k++;
            }
            else{
                j = 12;
                k = 1;
            }
            break;
        case 12:
            if(k < 31){
                k++;
                break;
            }
            if(i < 2005){
                i++;
	    }
            j = 1;
            k = 1;
            break;
        }
        koyomi.SetDay(i, j, k);
    }

    public void OnKinou()
    {
        int i = koyomi.year;
        int j = koyomi.month;
        int k = koyomi.day;
        if(k > 1)
            k--;
        else
            switch(j){
            default:
                break;
            case 1:
                if(i > 1996){
                    i--;
		}
                j = 12;
                k = 31;
                break;
            case 2:
                j = 1;
                k = 31;
                break;
            case 3:
                j = 2;
                k = 28;
                if(koyomi.uru_flag == 1){
                    k = 29;
		}
                break;
            case 4:
                j = 3;
                k = 31;
                break;
            case 5:
                j = 4;
                k = 30;
                break;
            case 6:
                j = 5;
                k = 31;
                break;
            case 7:
                j = 6;
                k = 30;
                break;
            case 8:
                j = 7;
                k = 31;
                break;
            case 9:
                j = 8;
                k = 31;
                break;
            case 10:
                j = 9;
                k = 30;
                break;
            case 11:
                j = 10;
                k = 31;
                break;
            case 12:
                j = 11;
                k = 30;
                break;
            }
        koyomi.SetDay(i, j, k);
    }
    public void set_kyusei()
    {
	KyuseiName[0]=new String("IppakuSuisei");
	KyuseiName[1]=new String("JikokuDosei");
	KyuseiName[2]=new String("SanpekiMokusei");
	KyuseiName[3]=new String("SirokuMokusei");
	KyuseiName[4]=new String("GoouDosei");
	KyuseiName[5]=new String("RoppakuKinsei");
	KyuseiName[6]=new String("ShichisekiKinsei");
	KyuseiName[7]=new String("HappakuDosei");
	KyuseiName[8]=new String("KyuushiKasei");
    }
    public void set_eto()
    {
	EtoName[0]=new String("KinoeNe");
	EtoName[1]=new String("KinotoUshi");
	EtoName[2]=new String("HinoeTora");
	EtoName[3]=new String("HinotoU");
	EtoName[4]=new String("TsuchinoeTatsu");
	EtoName[5]=new String("TsuchinotoMi");
	EtoName[6]=new String("KanoeUma");
	EtoName[7]=new String("KanotoHitsuji");
	EtoName[8]=new String("MizunoeSaru");
	EtoName[9]=new String("MizunotoTori");
	EtoName[10]=new String("KinoeInu");
	EtoName[11]=new String("KinotoI");
	EtoName[12]=new String("HonoeNe");
	EtoName[13]=new String("HinotoUshi");
	EtoName[14]=new String("TsuochinoeTora");
	EtoName[15]=new String("TsuchinotoU");
	EtoName[16]=new String("KanoeTatsu");
	EtoName[17]=new String("KanotoMi");
	EtoName[18]=new String("MizunoeUma");
	EtoName[19]=new String("MizunotoHitsuji");
	EtoName[20]=new String("KinoeSaru");
	EtoName[21]=new String("KinotoTori");
	EtoName[22]=new String("HinoeInu");
	EtoName[23]=new String("HinotoI");
	EtoName[24]=new String("TsuchinoeNe");
	EtoName[25]=new String("TsuchinotoUshi");
	EtoName[26]=new String("KanoeTora");
	EtoName[27]=new String("KanotoU");
	EtoName[28]=new String("MozunoeTatsu");
	EtoName[29]=new String("MizunotoMi");
	EtoName[30]=new String("KinoeUma");
	EtoName[31]=new String("KinotoHitsuji");
	EtoName[32]=new String("HinoeSaru");
	EtoName[33]=new String("HinotoTori");
	EtoName[34]=new String("TsuchinoeInu");
	EtoName[35]=new String("TsuchinotoI");
	EtoName[36]=new String("KanoeNe");
	EtoName[37]=new String("KanotoUshi");
	EtoName[38]=new String("MizunoeTora");
	EtoName[39]=new String("MizunotoU");
	EtoName[40]=new String("KinoeTatsu");
	EtoName[41]=new String("KinotoMi");
	EtoName[42]=new String("HinoeUma");
	EtoName[43]=new String("HinotoHitsuji");
	EtoName[44]=new String("TsuchinoeSaru");
	EtoName[45]=new String("TsuchinotoTori");
	EtoName[46]=new String("KanoeInu");
	EtoName[47]=new String("KanotoI");
	EtoName[48]=new String("MizunoeNe");
	EtoName[49]=new String("MizunotoUshi");
	EtoName[50]=new String("KinoeTora");
	EtoName[51]=new String("KinotoU");
	EtoName[52]=new String("HinoeTatsu");
	EtoName[53]=new String("HinotoMi");
	EtoName[54]=new String("TsuchinoeUma");
	EtoName[55]=new String("TsuchinotoHitsuji");
	EtoName[56]=new String("KanoeSaru");
	EtoName[57]=new String("KanotoTori");
	EtoName[58]=new String("MizunoeInu");
	EtoName[59]=new String("MizunotoI");

    }
    public void set_rokuyo()
    {
	RokuName[0]=new String("SenSho");
	RokuName[1]=new String("TomoBiki");
	RokuName[2]=new String("SenBu");
	RokuName[3]=new String("ButsuMetsu");
	RokuName[4]=new String("TaiAn");
	RokuName[5]=new String("ShaKKo");
    }
    public void onPaint(Graphics g){
	FontMetrics fm = new FontMetrics(plainFont, this);
	g.setColor(0, 0, 0);
	String date = "date" + koyomi.year + "/" + koyomi.month + "/" + koyomi.day;
	//	String roku = "Roku #" + koyomi.rokuyou_no;
	g.setFont(plainFont);
	g.drawText(date, 0, 20);

	int i=koyomi.rokuyou_no+1;
	String rfilename = "roku"+i+".bmp";
	RokuImage=new Image(rfilename);
	g.drawImage(RokuImage, 0, 35); // 60 x 30
	g.drawText(RokuName[koyomi.rokuyou_no], 0, 65);

	String kfilename = "kyusei"+koyomi.kyuusei_day_no+".bmp";
	KyuseiImage=new Image(kfilename);
	g.drawImage(KyuseiImage, 0, 78); //80 x20
	g.drawText(KyuseiName[koyomi.kyuusei_day_no], 0, 98);

	String filename = "eto"+koyomi.eto_day_no+".bmp";
	EtoImage=new Image(filename);
	g.drawImage(EtoImage, 0, 111);
	g.drawText(EtoName[koyomi.eto_day_no], 0, 131);
    }
} // wathello



